Subject: Re: [RFC PATCH] Initialize dev_id sysfs attribute to -1 by default

From: John Fastabend <[email-masked]>
Date: Fri, 07 Jun 2013 07:45:19 -0700

On 5/31/2013 5:17 AM, [email-masked] wrote:
> On Thu, May 30, 2013 at 07:08:46PM +0530, Bjørn Mork wrote:
>>
>> <[email-masked]> writes:
>>
>>> From: Narendra K <[email-masked]>
>>>
>>> 'dev_id' sysfs attribute is initialized to zero by default.
>>> It is also zero based. This creates ambiguity in differentiating
>>> whether the driver set it to zero or it is the default value.
>>> Initialize 'dev_id' to -1 to make the scenario unambiguous.
>>
>> I understand your concern, but I don't think you can do this.  It
>> changes the userspace API, and has some very visible side effects.
>>
>> Please take a look at net/ipv6/addrconf.c
>
> Ok, thank you for pointing it. I missed it while looking for its
> possible use scenarios.

Although I'm not sure how that check works with devices that are
setting dev_id and also provide their own mac addresses. From
inspection it looks like these devices end up with a local interface
identifier unnecessarily.

Maybe Ben knows one of the drivers is the siena solorflare controller
apparently for the SFC9000 family? The other two 'grep' finds are
an mlx and chelsio device.

Interestingly I didn't find any devices setting dev_id that also
didn't program unique mac addresses. Perhaps I'm missing something?

Thanks,
John